<%--
%(C) COPYRIGHT International Business Machines Corp. 2014, All Rights Reserved
%US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%><%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8"
%><%@ page import="com.emptoris.framework.sso.SSMUserRegistryImpl"
%><%@ page import="com.ibm.ws.security.util.Constants"
%><%@ page import="com.rivermine.app.branding.BrandingUtility"
%><%@ page import="com.rivermine.app.gateway.GatewayProperties"
%><%@ page import="com.rivermine.config.property.system.SuiteApplicationDefinition"
%><%@ page import="com.rivermine.model.mdm.ApplicationUser.AuthType"
%><%@ page import="com.rivermine.util.CookieUtil"
%><%@ page import="com.rivermine.util.StringUtil"
%><%
Cookie[] cookies = request.getCookies();
String contextPath = CookieUtil.getValidatedPath(request.getContextPath());
String kindOfAuth = request.getParameter(CookieUtil.KIND_OF_AUTH_PARAM_NAME);
String targetApp = request.getParameter(CookieUtil.TARGET_APP_PARAM_NAME);
Cookie targetAppCookie = CookieUtil.getCookieByName(CookieUtil.TARGET_APP_PARAM_NAME, cookies);
if (StringUtil.isEmptyString(targetApp) && targetAppCookie != null)
{
    targetApp = targetAppCookie.getValue();
}
if (StringUtil.isEmptyString(targetApp))
{
    targetApp = SSMUserRegistryImpl.SSM;
}
CookieUtil.addCookie(response, CookieUtil.TARGET_APP_PARAM_NAME, targetApp, contextPath);
boolean isOAuth = false;
String targetUrl = null;
Cookie destinationCookie = CookieUtil.getCookieByName(Constants.REFERER_URL_COOKIENAME, cookies);
Cookie targetUrlCookie = CookieUtil.getCookieByName(CookieUtil.TARGET_URL_COOKIE_NAME, cookies);
if (destinationCookie != null)
{
    targetUrl = destinationCookie.getValue();
    // WASReqURL cookie has base path "/"
    CookieUtil.removeCookie(response, destinationCookie, "/");
}
else if (targetUrlCookie != null)
{
    targetUrl = targetUrlCookie.getValue();
}
if (!StringUtil.isEmptyString(targetUrl))
{
    if (targetUrl.indexOf("oauth2") >= 0)
    {
        isOAuth = true;
    }
    int idx = targetUrl.indexOf(contextPath);
    if (idx == -1)
    {
        // close open/redirect hole
        targetUrl = "";
    }
    else
    {
        targetUrl = targetUrl.substring(idx);
        String koa = CookieUtil.KIND_OF_AUTH_PARAM_NAME + "=";
        int koaLen = koa.length();  // 11 "kindOfAuth="
        idx = targetUrl.indexOf(koa);
        if (idx >= 0 && targetUrl.length() >= idx + koaLen + 8)
        {
            // AuthType.External and AuthType.Internal names are both 8 characters
            kindOfAuth = targetUrl.substring(idx + koaLen, idx + koaLen + 8);
        }
        if (targetUrl.indexOf("sso_landing.jsp") >= 0 || targetUrl.indexOf("jaxrs") >= 0)
        {
            // ignore sso_landing.jsp and jaxrs calls
            targetUrl = "";
        }
        else
        {
            // VSM-2698 drop Echo2 AJAX request
            idx = targetUrl.indexOf("?serviceId=");
            if (idx >= 0)
            {
                targetUrl = targetUrl.substring(0, idx);
            }
        }
    }
    if (targetUrlCookie == null && !StringUtil.isEmptyString(targetUrl))
    {
        // add targetUrl cookie if non-existent
        CookieUtil.addCookie(response, CookieUtil.TARGET_URL_COOKIE_NAME, targetUrl, contextPath);
    }
}
String forwardUrl = null;
if (isOAuth)
{
    forwardUrl = SuiteApplicationDefinition.SSM_CONTEXT_ROOT + "/oauth_login.jsp";
}
else
{
    String isExternalAuthString = request.getParameter(CookieUtil.KIND_OF_AUTH_PARAM_NAME);
    Cookie isExternalAuthCookie = CookieUtil.getCookieByName(CookieUtil.EXTERNAL_AUTH_COOKIE_NAME, cookies);
    if (StringUtil.isEmptyString(kindOfAuth) && isExternalAuthCookie != null)
    {
        kindOfAuth = Boolean.TRUE.toString().equalsIgnoreCase(isExternalAuthCookie.getValue())
            ? AuthType.External.name() : AuthType.Internal.name();
    }
    boolean isExternalAuth = AuthType.External.name().equalsIgnoreCase(kindOfAuth);
    if (isExternalAuth && request.getUserPrincipal() == null)
    {
        forwardUrl = GatewayProperties.getSSOLoginURLForExternalAuth();
    }
}
if (StringUtil.isEmptyString(forwardUrl))
{
    forwardUrl = SuiteApplicationDefinition.SSM_CONTEXT_ROOT + "/sso_login.jsp";
}
if (Boolean.TRUE.toString().equals(request.getParameter(CookieUtil.ERROR_PARAM_NAME)))
{
    forwardUrl = CookieUtil.appendQueryParam(forwardUrl, CookieUtil.ERROR_PARAM_NAME, Boolean.TRUE.toString());
}
else if (Boolean.TRUE.toString().equals(request.getParameter(CookieUtil.TIMEOUT_PARAM_NAME)))
{
    forwardUrl = CookieUtil.appendQueryParam(forwardUrl, CookieUtil.TIMEOUT_PARAM_NAME, Boolean.TRUE.toString());
}
response.setHeader("Pragma", "no-cache");
response.setHeader("Cache-Control", "private, no-cache, no-store");
response.setDateHeader("Expires", 0);
//System.err.println("      LOGIN ====================targetApp: " + targetApp);
%><!DOCTYPE HTML>
<HTML>
<HEAD>
<TITLE>sso_login.jsp</TITLE>
<LINK rel="icon" type="image/x-icon" href="favicon.ico?_=<%= BrandingUtility.getActiveLogosDeployTime(request) %>">
<META http-equiv="refresh" content="0; url=<%= forwardUrl %>">
</HEAD>
</HTML>
